#! /bin/bash
cd $(dirname $0)
platform=$(uname -m)
if 
	echo $platform | grep i[4-6]86 >/dev/null
then
	platform=i386
fi
inst=$PWD
dos2unix dos2unix_mod.sh
chmod +x dos2unix_mod.sh
$inst/dos2unix_mod.sh kelp.properties
cd ../../..
if
	kelp=$(ls -ld [Kk]elp-src*  2>/dev/null | grep "^d"| tail -1 | awk '{print $NF}')
	[ ! -d ${kelp:=Kelp-src} ]
then
	cd $inst/../..
	kelp=$PWD
else
	version=$(echo $kelp | sed "s/[Kk]elp-src//")
fi
	cd $inst
if
	ver=$(grep "[ 	]*version=" kelp.properties)
then
	eval $ver
fi

eval $(grep "[   ]*release=" kelp.properties)
version=${version:=5.1}
release=${release:=1}
find $kelp -type d -name classes -exec rm -rf {} \;
find $kelp -type d -name output -exec rm -rf {} \;

cd $inst/..
dist_dir=$PWD
rm -rf   /tmp/kelp-$version-$release
rm -rf   $dist_dir/kelp-$version-$release
rm -rf   $dist_dir/Kelp*
mkdir /tmp/kelp-$version-$release
cp -p -r $kelp/*  /tmp/kelp-$version-$release
mv /tmp/kelp-$version-$release $dist_dir
cd $dist_dir/kelp-$version-$release
dist_kelp=$PWD
cd -
rm -rf /tmp/kelp-$version-$release
RPM=/usr/src/redhat
rm -f $RPM/SPECS/kelp-$version-$release.spec
$inst/dos2unix_mod.sh  $kelp/install/SPECS/kelp.spec
sed  "
/Version: /s/:.*$/: $version/
/Release: /s/:.*$/: $release/
" $kelp/install/SPECS/kelp.spec >>$RPM/SPECS/kelp-$version-$release.spec
cp -p  $kelp/modules/AddinConfigure/dist/jbuilder/lib/Enhydra.library.in $dist_kelp
find  $dist_kelp/install -name configure -exec chmod +x {} \;
find  $dist_kelp/install \( -name configure -o -name "*.sh" -o -name "*.sed" \) -print -exec $inst/dos2unix_mod.sh {} \;
cd  $dist_dir
find kelp-$version-$release -type d -exec chmod a+rx {} \;
find kelp-$version-$release -type f -exec chmod a+r {} \;
tar -czvf $RPM/SOURCES/kelp-$version-$release.src.tar.gz  kelp-$version-$release
ls -l  $RPM/SOURCES/
if
	[ $? -ne 0 ]
then
	echo "tar archive could not be created; exiting"
        exit 2
fi

while
	read l
do
	if
		echo $l | egrep '[ 	]*#
^[ 	]*$
^[ 	]*-[ 	]*$' >/dev/null
	then
		continue
	fi
	l=$(echo $l | sed 's/=/ /')
	set - $l
	eval $1=$2
done <$inst/kelp.properties
if
	[ x${jdk_home:=$JDK_HOME} = x ]
then
	echo "jdk_home must be set in kelp.properties or"
	echo "environmnent varibale JDK_HOME must be set; exiting" 
	exit 3
fi
if
	[[ -d $jdk_home ]]
then
	JDK_HOME=$jdk_home
else
	JDK_HOME=$(which java/../..)
fi
if
	! $JDK_HOME/bin/java -version >/dev/null
then
	echo Invalid JAVA_HOME, no Java found
	exit 1
fi
export JDK_HOME
if [ -f ~/.rpmmacros ]
then
	mv  ~/.rpmmacros  ~/.rpmmacros.save
fi
echo "%debug_package %{nil}" > ~/.rpmmacros
jbuilder6=${jbuilder6_dir:=-}
jbuilder7=${jbuilder7_dir:=-}
jbuilder8=${jbuilder8_dir:=-}
jbuilder9=${jbuilder9_dir:=-}
netbeans=${netbeans_dir:=-}
netbeans34=${netbeans34_dir:=-}
netbeans35=${netbeans35_dir:=-}
eclipse=${eclipse_dir:=-}
eclipse21=${eclipse21_dir:=-}
jdeveloper=${jdeveloper_dir:=-}
echo -e "\n\n\n"
echo "Enhydra dir.    :	" $enhydra_dir
echo "JBuilder6 dir.  :	" $jbuilder6_dir
echo "JBuilder7 dir.  :	" $jbuilder7_dir
echo "JBuilder8 dir.  :	" $jbuilder8_dir
echo "JBuilder9 dir.  :	" $jbuilder9_dir
echo "NetBeans dir.   :	" $netbeans_dir
echo "NetBeans3.4 dir.:	" $netbeans34_dir
echo "NetBeans3.5 dir.:	" $netbeans35_dir
echo "Eclipse dir.    :	" $eclipse_dir
echo "Eclipse2.1 dir. :	" $eclipse21_dir
echo "JDeveloper dir. :	" $jdeveloper_dir

echo -e "\n\n\nIs that right(y/n)? [y]: \c"
read ans
if
	[[ y${ans:=y} != yy ]]
then
	exit 1
fi
{
	echo $enhydra_dir
	echo $jbuilder6_dir
	echo $jbuilder7_dir
	echo $jbuilder8_dir
	echo $jbuilder9_dir
	echo $netbeans_dir
	echo $netbeans34_dir
	echo $netbeans35_dir
	echo $eclipse_dir
	echo $eclipse21_dir
	echo $jdeveloper_dir
} | rpmbuild -ba $RPM/SPECS/kelp-$version-$release.spec
if
	[ $? != 0 ]
then
	exit 1
fi
rm -f  ~/.rpmmacros
if [ -f ~/.rpmmacros.save ]
then
	mv  ~/.rpmmacros.save  ~/.rpmmacros
fi
if
	[ $? -ne 0 ]
then
	echo "rpm archives could not be created; exiting"
        exit 3
fi
mkdir -p Kelp-$version-$release/Kelp-install/Linux/RPM
mkdir -p Kelp-$version-$release/Kelp-install/Linux/TAR.GZ
mkdir -p Kelp-$version-$release/Kelp-src/Linux/

cp -p  $RPM/SRPMS/kelp-$version-$release.src.rpm  Kelp-$version-$release/Kelp-src/Linux/
cp -p  $RPM/SOURCES/kelp-$version-$release.src.tar.gz  Kelp-$version-$release/Kelp-src/Linux

for name in \
	jbuilder6_dir:jbuilder:JBuilder6 \
	jbuilder7_dir:jbuilder7:JBuilder7 \
	jbuilder8_dir:jbuilder8:JBuilder8 \
	jbuilder9_dir:jbuilder9:JBuilder9 \
	netbeans_dir:netbeans:NetBeans \
	netbeans34_dir:netbeans34:NetBeans34 \
	netbeans35_dir:netbeans35:NetBeans35 \
	eclipse_dir:eclipse:eclipse \
	eclipse21_dir:eclipse21:eclipse21 \
	jdeveloper_dir:jdeveloper:jdeveloper
do
	name=$(echo $name | sed 's/:/ /g')
	set - $name
	dir=$1
	eval dir='$'$dir
	if
		[ $dir != '-' ]
	then
		file=$2
		Cfile=$3
		rm -rf tmp
		rpm2cpio $RPM/RPMS/${platform}/kelp-${file}-${version}-${release}.${platform}.rpm | cpio -id 
		mv tmp/kelp-$version/$Cfile/install.sh tmp
		cd tmp
		find . -type d -exec chmod a+rx {} \;
		find . -type f -exec chmod a+r {} \;
		find . -type f \( -name '*.sh' -o -name configure \) -exec chmod a+rx {} \;
		tar -czvf ../Kelp-$version-$release/Kelp-install/Linux/TAR.GZ/kelp-${file}-${version}-${release}.tar.gz  *
		cd ..
		cp -p  $RPM/RPMS/${platform}/kelp-${file}-${version}-${release}.${platform}.rpm  Kelp-$version-$release/Kelp-install/Linux/RPM
	fi
done
rm -rf tmp kelp-$version-$release
chmod a+r Kelp-$version-$release/Kelp-install/Linux/RPM/*
chmod a+r Kelp-$version-$release/Kelp-src/Linux/*
chmod a+r Kelp-$version-$release/Kelp-install/Linux/TAR.GZ/*
