;------------------------------------------------------------------------------
; Enhydra 5.1 installation script
;	All output message will be written to file ..\..\..\..\netbeans.log
;------------------------------------------------------------------------------
#!define VERSION "5.1" ;Define your own software name here
#!define RELEASE "1" ; need for building with makensisw.exe
;--------------------------------
;Version Information
  VIProductVersion "5.1.0.0"
;--------------------------------
!define MUI_PRODUCT "Kelp ${VERSION} for NetBeans" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here
!define MUI_NAME "${MUI_PRODUCT}"

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "Uninstall ${MUI_PRODUCT}"
!define MUI_UNTEXT_INTRO_SUBTITLE "Remove ${MUI_PRODUCT} from your computer."

!include "MUI.nsh"
;--------------------------------------------------------------------------
!macro ReplaceInFile SOURCE_FILE SEARCH_TEXT REPLACEMENT
  Push "${SOURCE_FILE}"
  Push "${SEARCH_TEXT}"
  Push "${REPLACEMENT}"
  Call RIF
!macroend
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !define MUI_BRANDINGTEXT "Kelp Windows Installation "
  !insertmacro MUI_LANGUAGE "English"

# General
	OutFile "..\..\..\..\distribution\kelp-netbeans-${VERSION}-${RELEASE}.setup.exe"	; The file to write

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory :"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
# Window titles
    LangString TEXT_IO_TITLE_JDK ${LANG_ENGLISH} "Upgrade the shared JDK definition to JDK 1.4.x"
    LangString TEXT_IO_PAGESUBTITLE_A_JDK ${LANG_ENGLISH} "Important notice!!!"
    LangString TEXT_IO_PAGESUBTITLE_B_JDK ${LANG_ENGLISH} "For using Kelp with NetBeans you must upgrade the JDK definition to JDK 1.4.x so if you don't upgrade the JDK definition to JDK 1.4.x Kelp, only the part of it will work. You must do this manualy by setting the -jdkhome jdk_home_dir parameter in the ide.cfg file or select check box bellow and installation will do this for you. IF YOU HAVE ALREADY DONE THIS, DON'T SELECT CHECK BOX BELLOW."
    LangString TEXT_IO_PAGETITLE_A_JDK ${LANG_ENGLISH} ""
    LangString TEXT_IO_TITLE_A_JDK ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_CANCEL_A_JDK ${LANG_ENGLISH} "&Cancel"
    LangString TEXT_IO_NEXT_A_JDK ${LANG_ENGLISH} "&Next >"
    LangString TEXT_IO_BACK_A_JDK ${LANG_ENGLISH} "< &Back"

# Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  Page custom SetCustomPageJDK "" "$(TEXT_IO_PAGETITLE_A_JDK)" ; set using JDK 1.4.x with NetBeans IDE
  Page custom SetCustomPage
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Kelp"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Kelp ${VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "netbeans.ini"
  ReserveFile "jdk14x.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  ; Set output path to the installation directory.
  StrCpy $R5 $INSTDIR
  StrCpy $INSTDIR "$INSTDIR\Kelp5"
  StrCpy $OUTDIR "$INSTDIR\Kelp5"
  SetOutPath $INSTDIR

  File /r "..\..\NetBeans\*.*"
	  
  !insertmacro MUI_INSTALLOPTIONS_READ $2 "netbeans.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $3 "netbeans.ini" "Field 4" "State" ;JDK Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $9 "jdk14x.ini" "Field 3" "state" 
  StrCmp $9 0 continue
#Dumpstate::debug
  Call UpgradeJDKConfig
#  MessageBox MB_OK "End-Call UpgradeJDKConfig"
#Dumpstate::debug

  continue:
  ClearErrors
#  ExecWait '"$INSTDIR\configure.bat" "$R5" "$2"' $0	; start configuring Kelp
#Dumpstate::debug
	nsExec::ExecToLog '"$INSTDIR\configure.bat" "$R5" "$2"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout

  StrCmp $0 "0" success
	
	DetailPrint "Kelp ${VERSION} failed (output: $0)"
	Call Cleanup
	Goto end
	success:

	DetailPrint "Kelp ${VERSION} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans" "DisplayName" "Kelp ${VERSION} for NetBeans IDE (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp ${VERSION} for NetBeans"
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for NetBeans\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
	
	end:
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForNetBeans.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "netbeans.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "jdk14x.ini"

  ReadRegStr $R0 HKLM "SOFTWARE\NetBeans\3.3.1" "PATH" 
  StrCmp $R0 "" continue
  StrCpy $INSTDIR $R0
  continue:

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"
 
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for NetBeans\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for NetBeans"
  RMDir /r "$INSTDIR"
  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
Function GetParent
  Exch $0 ; old $0 is on top of stack
  Push $1
  Push $2
  StrCpy $1 -1
  loop:
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit
    StrCmp $2 "\" exit
    IntOp $1 $1 - 1
  Goto loop
  exit:
    StrCpy $0 $0 $1
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

#  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"

  Call CheckEnhydraInstall  ; Check if Enhydra Server installed
	Call IfJavaExist          ; check if JAVA_HOME directory exist

	start:
	
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "netbeans.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error

  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "netbeans.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "netbeans.ini" "Field 4" "State" ;JDK Directory

	IfFileExists ${TEMP2}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP2}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP2}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP2}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP2}\jre\lib\jsse.jar checkEnhydra	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP2}\jre\lib"
	Goto start

	checkEnhydra:
	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP2}\lib"
	Goto start

  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

	end:
	Pop $R0
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "netbeans.ini" "Field 4" "State"

  StrCmp ${TEMP2} "" end
  
	; predict if exist enviroment variable JAVA_HOME
  ReadEnvStr $6 "JAVA_HOME"

  StrCmp $6 "" notsetJAVA_HOME

	IfFileExists $6\bin\javac.exe OK ; check if javac.exe exist
	Goto notsetJAVA_HOME

  notsetJAVA_HOME:
 	ReadRegStr $6 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\java.exe" "Path"
 	Push $6
  StrCmp $6 "" notregjava
 	Call GetParent
 	Pop $6
  StrCmp $6 "" notregjava
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto notregjava

	notregjava:
	ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $6 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
 	Push $6
#  StrCmp $6 "" end
# 	Call GetParent
# 	Pop $6
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Field 4" "State" "$6"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for NetBeans\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for NetBeans"
  RMDir /r "$INSTDIR"
  
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra${VERSION}" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans.ini" "Field 2" "State" $R0 
  
  end:
FunctionEnd
;---------------------------------------------------------------------------------------------------------------------
; $2 - Enhydra Dir
; $3 - JDK Dir
;
; 1.Trazi se u fajli "-jdkdir ", ako se nadje proveri se da li je sledeci karakter "-" ako jeste nista se ne radi ako NIJE
; uzima se sledeca rec i ta rec se zamenjuje sa vrednoscz $3, ako ne postoji "-jdkdir " onda se na kraj reda dodaje 
; "-jdkdir $3"
; 2. trazi se u fajlu "-cp:p ", ako se nadje proveri se da li je sledeci karakter "-" ako jeste nista se ne radi ako NIJE
; uzima se sledeca rec i ta rec se zamenjuje sa vrednoscu $2
;---------------------------------------------------------------------------------------------------------------------
Function Configure_ide.cfg

#MessageBox MB_OK "Configure_ide.cfg"

; check if string "-jdkdir " exist
Push "$INSTDIR\bin\ide.cfg"
Push "-jdkdir "
Call FileSearch 
Pop $0 #Number of times found throughout 
Pop $1 #Found at all? yes/no 
Pop $2 #Number of lines found in 
StrCmp $1 yes 0 nojdkhome 

FileOpen ${TEMP1} $INSTDIR\bin\ide.cfg r
FileRead ${TEMP1} $R0 

; found ->replace
Push $R0 ; "-jdkhome C:\J2SDK1~1.1 -J-Xmx96m -J-Xss1024k -J-Xms20m"
Call SplitFirstStrPart 
Pop $R0 ;1st part ["-jdkhome"] 
Pop $R1 ;rest ["C:\J2SDK1~1.1 -J-Xmx96m -J-Xss1024k -J-Xms20m"] 
Push $R1
Call SplitFirstStrPart 
Pop $R0 ;1st part ["C:\J2SDK1~1.1"] 
Pop $R1 ;rest ["-J-Xmx96m -J-Xss1024k -J-Xms20m"] 

!insertmacro ReplaceInFile "$INSTDIR\bin\ide.cfg" "$R0" "$3"
Goto enhydraclasspath

nojdkhome:
ClearErrors
IfFileExists "$INSTDIR\bin\ide.cfg.save" 0 start
Delete "ide.cfg.save"

start:
FileOpen ${TEMP2} "$INSTDIR\bin\ide.cfg" "r"
GetTempFileName $R0
FileOpen ${TEMP1} $R0 "w"
FileRead ${TEMP1} $R0 
FileWrite ${TEMP1} "$R0 -jdkhome $3$\r$\n" 
FileClose ${TEMP1}
FileClose ${TEMP2}
Rename "$INSTDIR\bin\ide.cfg" "$INSTDIR\bin\ide.cfg.save"
CopyFiles /SILENT $R0 "$INSTDIR\bin\ide.cfg"
Delete $R0

enhydraclasspath:
; check if string "-cp:p " exist
Push "$INSTDIR\bin\ide.cfg"
Push "-cp:p "
Call FileSearch 
Pop $0 #Number of times found throughout 
Pop $1 #Found at all? yes/no 
Pop $2 #Number of lines found in 
StrCmp $1 yes 0 noecp 

FileOpen ${TEMP1} "$INSTDIR\bin\ide.cfg" r
FileRead ${TEMP1} $R0 

; found ->replace
Push $R0 ; "-jdkhome C:\J2SDK1~1.1 -J-Xmx96m -J-Xss1024k -J-Xms20m -cp:p C:\Enhydra5.1\lib\build\toolbox.jar"
Call SplitFirstStrPart 
Pop $R0 ;1st part ["-jdkhome C:\J2SDK1~1.1 -J-Xmx96m -J-Xss1024k -J-Xms20m -cp:p"] 
Pop $R1 ;rest ["C:\Enhydra5.1\lib\build\toolbox.jar"] 
Push $R1
Call SplitFirstStrPart 
Pop $R0 ;1st part ["C:\Enhydra5.1\lib\build\toolbox.jar"] 
Pop $R1 ;rest [""] 

!insertmacro ReplaceInFile "$INSTDIR\bin\ide.cfg" "$R0" "$2"
Goto end
noecp:
FileOpen ${TEMP2} "$INSTDIR\bin\ide.cfg" "r"
GetTempFileName $R0
FileOpen ${TEMP1} $R0 "w"
FileRead ${TEMP1} $R0 
FileWrite ${TEMP1} "$R0 -cp:p $2\lib\build\toolbox.jar;$2\lib\enhydra.jar;$2\lib\xercesImpl.jar;$2\lib\xml-apis.jar;$2\lib\bcel.jar;$2\lib\tomcat.jar;$2\lib\core.jar;$2\lib\util.jar;$2\lib\gnu-regexp.jar;$2\lib\dom\xmlc-chtml.jar;$2\lib\dom\xmlc-voicexml.jar;$2\lib\dom\xmlc-wml.jar;$2\lib\xhtml.jar;$2\lib\log4j.jar;$2\dods\lib\dods-runtime.jar;$2\dods\lib\dods.jar$\r$\n" 
FileClose ${TEMP1}
FileClose ${TEMP2}
Rename "$INSTDIR\bin\ide.cfg" "$INSTDIR\bin\ide.cfg.save"
CopyFiles /SILENT $R0 "$INSTDIR\bin\ide.cfg"
Delete $R0

end:
FunctionEnd
;---------------------------------------------------------------------------------------------------------------------
; $2 - Enhydra Dir
; $3 - JDK Dir
;
; 1.Trazi u fajlu ide.policy "grant {", ako nadje u sledecem redu trazi "permission java.security.AllPermission;" a ako to 
; nadje u sledecem redu trazi "};"
;---------------------------------------------------------------------------------------------------------------------
Function Configure_ide.policy

#MessageBox MB_OK "Configure_ide.policy"

; check if string "grant {" exist
Push "$INSTDIR\bin\ide.policy"
Push "grant {"
Call FileSearch 
Pop $0 #Number of times found throughout 
Pop $1 #Found at all? yes/no 
Pop $2 #Number of lines found in 
StrCmp $1 yes 0 no

StrCpy $R1 0 ; temp variable, keep if found needed string 
FileOpen ${TEMP1} $INSTDIR\bin\ide.policy r
loop:
ClearErrors
FileRead ${TEMP1} $R0 
IfErrors end
; Remove leading and trailing whitespaces from a string 
Push $R0
Call Trim
Pop $R0
StrCmp $R0 "grant {" continue
Goto loop

continue:
ClearErrors
FileRead ${TEMP1} $R0 
IfErrors endOfFile
; Remove leading and trailing whitespaces from a string 
Push $R0
Call Trim
Pop $R0
StrCmp $R0 "permission java.security.AllPermission;" continue1
Goto loop

continue1:
ClearErrors
FileRead ${TEMP1} $R0 
IfErrors end
; Remove leading and trailing whitespaces from a string 
Push $R0
Call Trim
Pop $R0
StrCmp $R0 "};" "" loop
StrCpy $R1 1

endOfFile:
StrCmp $R1 "1" end

no:
Call FilePolicyAppend

end:
FunctionEnd
;-----------------------------------------------------------------------------
; FileSearch - Search for text in file 
;-----------------------------------------------------------------------------
Function FileSearch
Exch $0 ;search for
Exch
Exch $1 ;input file
Exch
Push $2
Push $3
Push $4
Push $5
Push $6
Push $7
Push $8
Push $9
Push $R0
  FileOpen $2 $1 r
  StrLen $4 $0
  StrCpy $5 0
  StrCpy $7 no
  StrCpy $8 0
  StrCpy $9 0
loop_main:
  FileRead $2 $3
  IfErrors done
 IntOp $R0 $R0 + $9
  StrCpy $9 0 
filter_top:
 IntOp $5 $5 - 1
  StrCpy $6 $3 $4 $5
  StrCmp $6 "" loop_main
  StrCmp $6 $0 0 filter_top
  StrCpy $3 $3 $5
  StrCpy $5 0
 StrCpy $7 yes
 StrCpy $9 1
 IntOp $8 $8 + 1
Goto filter_top
done:
  FileClose $2
  StrCpy $0 $8
  StrCpy $1 $7
  StrCpy $2 $R0
Pop $R0
Pop $9
Pop $8
Pop $7
Pop $6
Pop $5
Pop $4
Pop $3
Exch 2
Exch $2 ;output number of lines
Exch 2
Exch
Exch $1 ;output yes/no
Exch
Exch $0 ;output count found
FunctionEnd
;--------------------------------------------------------------------------------------
;
;---------------------------------------------------------------------------------------
Function RIF

  ClearErrors  ; wanna be a newborn

  Exch $0      ; REPLACEMENT
  Exch
  Exch $1      ; SEARCH_TEXT
  Exch 2
  Exch $2      ; SOURCE_FILE

  Push $R0     ; SOURCE_FILE file handle
  Push $R1     ; temporary file handle
  Push $R2     ; unique temporary file name
  Push $R3     ; a line to sar/save
  Push $R4     ; shift puffer

  IfFileExists $2 +1 RIF_error      ; knock-knock
  FileOpen $R0 $2 "r"               ; open the door

  GetTempFileName $R2               ; who's new?
  FileOpen $R1 $R2 "w"              ; the escape, please!

  RIF_loop:                         ; round'n'round we go
    FileRead $R0 $R3                ; read one line
    IfErrors RIF_leaveloop          ; enough is enough
    RIF_sar:                        ; sar - search and replace
      Push "$R3"                    ; (hair)stack
      Push "$1"                     ; needle
      Push "$0"                     ; blood
      Call StrReplace               ; do the bartwalk
      StrCpy $R4 "$R3"              ; remember previous state
      Pop $R3                       ; gimme s.th. back in return!
      StrCmp "$R3" "$R4" +1 RIF_sar ; loop, might change again!
    FileWrite $R1 "$R3"             ; save the newbie
  Goto RIF_loop                     ; gimme more

  RIF_leaveloop:                    ; over'n'out, Sir!
    FileClose $R1                   ; S'rry, Ma'am - clos'n now
    FileClose $R0                   ; me 2

    Delete "$2.old"                 ; go away, Sire
    Rename "$2" "$2.old"            ; step aside, Ma'am
    Rename "$R2" "$2"               ; hi, baby!

    ClearErrors                     ; now i AM a newborn
    Goto RIF_out                    ; out'n'away

  RIF_error:                        ; ups - s.th. went wrong...
    SetErrors                       ; ...so cry, boy!

  RIF_out:                          ; your wardrobe?
  Pop $R4
  Pop $R3
  Pop $R2
  Pop $R1
  Pop $R0
  Pop $2
  Pop $0
  Pop $1

FunctionEnd
;-----------------------------------------------------------------------------
; Trim
;   Removes leading & trailing whitespace from a string
; Usage:
;   Push $R1
;   Call Trim
;   Pop $R1
;-----------------------------------------------------------------------------
Function Trim
	Exch $R1 ; Original string
	Push $R2

Loop:
	StrCpy $R2 "$R1" 1
	StrCmp "$R2" " " TrimLeft
	StrCmp "$R2" "$\r" TrimLeft
	StrCmp "$R2" "$\n" TrimLeft
	StrCmp "$R2" "	" TrimLeft ; this is a tab.
	GoTo Loop2
TrimLeft:	
	StrCpy $R1 "$R1" "" 1
	Goto Loop

Loop2:
	StrCpy $R2 "$R1" 1 -1
	StrCmp "$R2" " " TrimRight
	StrCmp "$R2" "$\r" TrimRight
	StrCmp "$R2" "$\n" TrimRight
	StrCmp "$R2" "	" TrimRight ; this is a tab
	GoTo Done
TrimRight:	
	StrCpy $R1 "$R1" -1
	Goto Loop2

Done:
	Pop $R2
	Exch $R1
FunctionEnd
;---------------------------------------------------------------------------------------
;
;---------------------------------------------------------------------------------------
function StrReplace
  Exch $0 ;this will replace wrong characters
  Exch
  Exch $1 ;needs to be replaced
  Exch
  Exch 2
  Exch $2 ;the orginal string
  Push $3 ;counter
  Push $4 ;temp character
  Push $5 ;temp string
  Push $6 ;length of string that need to be replaced
  Push $7 ;length of string that will replace
  Push $R0 ;tempstring
  Push $R1 ;tempstring
  Push $R2 ;tempstring
  StrCpy $3 "-1"
  StrCpy $5 ""
  StrLen $6 $1
  StrLen $7 $0
  Loop:
  IntOp $3 $3 + 1
  StrCpy $4 $2 $6 $3
  StrCmp $4 "" ExitLoop
  StrCmp $4 $1 Replace
  Goto Loop
  Replace:
  StrCpy $R0 $2 $3
  IntOp $R2 $3 + $6
  StrCpy $R1 $2 "" $R2
  StrCpy $2 $R0$0$R1
  IntOp $3 $3 + $7
  Goto Loop
  ExitLoop:
  StrCpy $0 $2
  Pop $R2
  Pop $R1
  Pop $R0
  Pop $7
  Pop $6
  Pop $5
  Pop $4
  Pop $3
  Pop $2
  Pop $1
  Exch $0
FunctionEnd
;---------------------------------------------------------------------------------------
;
;---------------------------------------------------------------------------------------
Function FilePolicyAppend

ClearErrors
IfFileExists "$INSTDIR\bin\ide.policy.save" 0 start
Delete "$INSTDIR\bin\ide.policy.save"

start:
FileOpen ${TEMP2} "$INSTDIR\bin\ide.policy" "r"
GetTempFileName $R0
FileOpen ${TEMP1} $R0 "w"
FileWrite ${TEMP1} "grant {$\r$\n"
FileWrite ${TEMP1} "permission java.security.AllPermission;$\r$\n"
FileWrite ${TEMP1} "};$\r$\n"

loop:
   FileRead ${TEMP2} $R1
   IfErrors done
   FileWrite ${TEMP1} $R1
   Goto loop

done:
   FileClose ${TEMP1}
   FileClose ${TEMP2}
   Rename "$INSTDIR\bin\ide.policy" "$INSTDIR\bin\ide.policy.save"
   CopyFiles /SILENT $R0 "$INSTDIR\bin\ide.policy"
   Delete $R0

FunctionEnd   
;------------------------------------------------------------------------------
; ReplaceChar
; input, input string  (C:\JBuilder\jdk1.3.1)
;        char to need replaced (\)
;        char to with replaced (/)
; output, top of stack (C:/JBuilder/jdk1.3.1)
; modifies no other variables.
;
; Usage:
;   Push $1 ; "C:\JBuilder\jdk1.3.1"
;   Push "\"
;   Push "/"
;   Call ReplaceChar
;   Pop $0
;   ; at this point $0 will equal "C:/JBuilder/jdk1.3.1"
;------------------------------------------------------------------------------
Function ReplaceChar
					; stack="/","\","C:\JBuilder\jdk1.3.1", ... (from top to down)
  Exch $2 ; $2="/", stack="2-gi param","\","C:\JBuilder\jdk1.3.1", ...
  Exch  	; stack="\","2-ti param","C:\JBuilder\jdk1.3.1", ...
  Exch $1 ; $1="\", stack="1-vi param","2-gi param","C:\JBuilder\jdk1.3.1", ...
  Exch    ; stack="2-gi param","1-vi param","C:\JBuilder\jdk1.3.1", ...
	Exch 2	; stack="C:\JBuilder\jdk1.3.1","1-vi param","2-gi param", ...
  Exch $0 ; $0="C:\JBuilder\jdk1.3.1", stack="0-ti param","1-vi param","2-gi param", ...
  Exch 2  ; stack="2-gi param","1-vi param","0-ti param", ...

  Push $3	; Len("C:\JBuilder\jdk1.3.1")
  Push $4	; index of string
  Push $5 ; tmp - form strat to found char witch need to change
  Push $6 ; tmp - from found char witch need to change + 1 to end ($3)
  Push $7 ; tmp - position where found char witch need to change + 1
  StrLen $3 $0
  StrCpy $4 1
  loop:
    StrCpy $5 $0 1 $4
    StrCmp $5 "" exit
    StrCmp $5 $1 change
    IntOp $4 $4 + 1
  Goto loop
  change:
  	StrCpy $6 $4				; pozition where found char witch need to change
  	StrCpy $5 $0 $6   	; $5="C:"
  	StrCpy $5 "$5$2"   	; $5="C:/"
  	StrCpy $7 $4				; pozition where found char witch need to change
  	IntOp $7 $7 + 1 		; next pozition
  	StrCpy $6 $0 $3 $7  ; $6="JBuilder\jdk1.3.1"
  	StrCpy $0 $5				; $0="C:/"
  	StrCpy $0 "$0$6" 		; $0="C:/JBuilder\jdk1.3.1"
  Goto loop
  exit:
    Pop $7
    Pop $6
    Pop $5
    Pop $4
    Pop $3
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  StrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 StrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 StrStr_done StrStr_loop

  StrStrReturn_notFound:
    StrCpy $2 -1

  StrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd
;------------------------------------------------------------------------------
; Page for choose java home directory
;------------------------------------------------------------------------------
Function SetCustomPageJDK

  StrCpy $R9 0 ; keep if selected upgrade the shared JDK definition to JDK 1.4.x
  
; set values in jdk14x.ini file
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "Title" "$(TEXT_IO_TITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 2" "Text" "$(TEXT_IO_PAGESUBTITLE_B_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "CancelButtonText" "$(TEXT_IO_CANCEL_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "NextButtonText" "$(TEXT_IO_NEXT_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "BackButtonText" "$(TEXT_IO_BACK_A_JDK)"
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE_JDK)" "$(TEXT_IO_SUBTITLE_JDK)"

  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "jdk14x.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error

  ; check if check box is selected
  !insertmacro MUI_INSTALLOPTIONS_READ $R1 "jdk14x.ini" "Field 3" "state" 
  StrCmp $R1 "0" end ; check if check box is selected
  StrCpy $R9 1
  Goto end
  
  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

  end:
FunctionEnd
;-------------------------------------------------------------------------------
; Usage:
; Push "string1|string2|string3|string4|string5" 
; Call SplitFirstStrPart 
; Pop $R0 ;1st part ["string1"] 
; Pop $R1 ;rest ["string2|string3|string4|string5"] 
;-------------------------------------------------------------------------------
Function SplitFirstStrPart
  Exch $R0
  Push $R1
  Push $R2
  StrLen $R1 $R0
  IntOp $R1 $R1 + 1
  loop:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 1 -$R1
    StrCmp $R1 0 exit0
    StrCmp $R2 " " exit1 loop ; Change " " to "\" if str=dirpath
  exit0:
  StrCpy $R1 ""
  Goto exit2
  exit1:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 "" -$R1
    IntOp $R1 $R1 + 1
    StrCpy $R0 $R0 -$R1
    StrCpy $R1 $R2
  exit2:
  Pop $R2
  Exch $R1 ;rest
  Exch
  Exch $R0 ;first
FunctionEnd
;--------------------------------------------------------------------------
; Upgrade the JDK definition to JDK 1.4.x in file ide.cfg
;--------------------------------------------------------------------------
Function UpgradeJDKConfig
#  $R5 $INSTDIR
#  $2 Enhydra Directory
#  $3 JDK Directory

ClearErrors
IfFileExists "$R5\bin\ide.cfg.save" 0 start
Delete "$R5\bin\ide.cfg.save"
start:
FileOpen $9 "$R5\bin\ide.cfg" "r"
GetTempFileName $R4
FileOpen $8 $R4 "w"

StrCpy $R9 "" ; keep all file string
StrCpy $R8 "" ; keep current line string
StrCpy $7 0   ; indikator da postoji string "jdkhome"
StrCpy $5 0   ; indikator ukupno procitanih redova iz fajla
StrCpy $R7 ""  ; acumulate current line tokens
#MessageBox MB_OK "1"
#Dumpstate::debug
looprow:
   FileRead $9 $6
   IfErrors done
   IntOp $5 $5 + 1

loopstring: ; check if "-jdkhome" exist in current line readed from file
   Push $6
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
#MessageBox MB_OK "2"
#Dumpstate::debug
   IntCmp $0 -1 looprow 
   StrCpy $R8 $6

loop:
    ; get frst part of string
   Push $R8
   Call SplitFirstStrPart 
   Pop $R0 ;1st part
   Pop $R1 ;rest 
#MessageBox MB_OK "3"
#Dumpstate::debug
   StrCpy $R8 $R1 ;keep rest of string
   
   ; check if "-jdkhome" exist in frst part of string
   Push $R0 ; 
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
#MessageBox MB_OK "4"
#Dumpstate::debug
   StrCmp $0 -1 "" getjdkhome
   StrCpy $R7 "$R7$R0 " ; $R7 = $R7 + first part of string + " "
   goto loop
   
getjdkhome:   
   ; read java_home directory from string
   Push $R1 ;rest
   Call SplitFirstStrPart 
   Pop $R0 ;directory of java_home
   Pop $R1 ;rest 
#MessageBox MB_OK "5"
#Dumpstate::debug
   StrCpy $R7 "$R7-jdkhome $3 $R1"
   StrCpy $7 1
      
done:
#MessageBox MB_OK "6"
#Dumpstate::debug
   StrCmp $5 1 0 multiline
   StrCmp $7 1 0 notexistjdk
   FileWrite $8 $R7
   goto end
notexistjdk:
#MessageBox MB_OK "7"
   FileSeek $9 0 ; set to top of file
   FileRead $9 $6
#Dumpstate::debug
   FileWrite $8 "-jdkhome $3 $6"
   goto end
       
multiline:
#MessageBox MB_OK "8"
#Dumpstate::debug
   FileSeek $9 0 ; set to top of file
   StrCmp $7 0 "" multiexistjdk
#MessageBox MB_OK "8-1"
   FileWrite $8 "-jdkhome $3$\r$\n"
   goto multiloop
multiexistjdk:   
#MessageBox MB_OK "8-2"
   FileWrite $8 $R7
multiloop:
   FileRead $9 $6
   IfErrors end
   Push $6
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
   IntCmp $0 -1 0 writejdkhome 
   FileWrite $8 $6
#MessageBox MB_OK "8-3-$$6=$6"
   goto multiloop 
writejdkhome:
   goto multiloop 

end:
#MessageBox MB_OK "9"
#Dumpstate::debug
   FileClose $9
#MessageBox MB_OK "10"
   FileClose $8
#MessageBox MB_OK "11"
   Rename "$R5\bin\ide.cfg" "$R5\bin\ide.cfg.save"
#MessageBox MB_OK "12-$$R4=$R4"
   CopyFiles /SILENT $R4 "$R5\bin\ide.cfg"
#MessageBox MB_OK "13"
   Delete $R4
#MessageBox MB_OK "14"
   StrCpy $0 0	; set OK
   
#MessageBox MB_OK "101"
#Dumpstate::debug

FunctionEnd
