;------------------------------------------------------------------------------
; Enhydra 5.1 installation script
;	All output message will be written to file ..\..\..\..\netbeans34.log
;------------------------------------------------------------------------------
#!define VERSION "5.1" ;Define your own software name here
#!define RELEASE "1" ; need for building with makensisw.exe
;--------------------------------
;Version Information
  VIProductVersion "5.1.0.0"
;--------------------------------
!define MUI_PRODUCT "Kelp ${VERSION} for NetBeans 3.4" ;Define your own software name here
!define MUI_VERSION "${VERSION}" ;Define your own software version here
!define MUI_NAME "${MUI_PRODUCT}"

!define MUI_ICON "${NSISDIR}\Contrib\Icons\enhydra1-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Icons\enhydra1-uninstall.ico"

# defines SF_*, SECTION_OFF and some macros
!include Sections.nsh

!define MUI_UNTEXT_INTRO_TITLE "Uninstall ${MUI_PRODUCT}"
!define MUI_UNTEXT_INTRO_SUBTITLE "Remove ${MUI_PRODUCT} from your computer."

!include "MUI.nsh"
;------------------------------------------------------------------------------
;Configuration
;------------------------------------------------------------------------------
  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_DIRECTORYPAGE
  
  !define MUI_ABORTWARNING

  !define MUI_CUSTOMPAGECOMMANDS
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

  !define TEMP1 $R0
  !define TEMP2 $R1
    
# Language
  !define MUI_BRANDINGTEXT "Kelp Windows Installation "
  !insertmacro MUI_LANGUAGE "English"

# General
	OutFile "..\..\..\..\distribution\kelp-netbeans3.4-${VERSION}-${RELEASE}.setup.exe"	; The file to write

# Install Options pages
# LANG_ENGLISH
# Header
    LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Please select the appropriate directories"
    LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Click button on right side to set the appropriate directories :"
# Window titles
    LangString TEXT_IO_PAGESUBTITLE_A ${LANG_ENGLISH} "Select Enhydra directory :"
    LangString TEXT_IO_PAGECUSTOM_A ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_PAGETITLE_A ${LANG_ENGLISH} ""
# Window titles
    LangString TEXT_IO_TITLE_JDK ${LANG_ENGLISH} "Upgrade the shared JDK definition to JDK 1.4.x"
    LangString TEXT_IO_PAGESUBTITLE_A_JDK ${LANG_ENGLISH} "Important notice!!!"
    LangString TEXT_IO_PAGESUBTITLE_B_JDK ${LANG_ENGLISH} "For using Kelp with NetBeans you must upgrade the JDK definition to JDK 1.4.x so if you don't upgrade the JDK definition to JDK 1.4.x Kelp, only the part of it will work. You must do this manualy by setting the -jdkhome jdk_home_dir parameter in the ide.cfg file or select check box bellow and installation will do this for you. IF YOU HAVE ALREADY DONE THIS, DON'T SELECT CHECK BOX BELLOW."
    LangString TEXT_IO_PAGETITLE_A_JDK ${LANG_ENGLISH} ""
    LangString TEXT_IO_TITLE_A_JDK ${LANG_ENGLISH} "${MUI_PRODUCT} Setup"
    LangString TEXT_IO_CANCEL_A_JDK ${LANG_ENGLISH} "&Cancel"
    LangString TEXT_IO_NEXT_A_JDK ${LANG_ENGLISH} "&Next >"
    LangString TEXT_IO_BACK_A_JDK ${LANG_ENGLISH} "< &Back"

# Page order 
	!insertmacro MUI_PAGE_WELCOME
	!insertmacro MUI_PAGE_LICENSE
  Page custom SetCustomPageJDK "" "$(TEXT_IO_PAGETITLE_A_JDK)" ; set using JDK 1.4.x with NetBeans IDE
  Page custom SetCustomPage "" "$(TEXT_IO_PAGETITLE_A)"
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  
# License page
  LicenseData /LANG=${LANG_ENGLISH} "${NSISDIR}\Contrib\License\LicenseEnglish.txt"

# Component-selection page
    ;Titles
    LangString TITLE_SecCopyUI ${LANG_ENGLISH} "Kelp"

# Descriptions
    LangString DESC_SecCopyUI ${LANG_ENGLISH} "Install Kelp ${VERSION} to the application folder."

# Folder-selection page
  InstallDir "C:\"
  
# Things that need to be extracted on startup (keep these lines before any File command!)
# Only useful for BZIP2 compression
# Use ReserveFile for your own Install Options ini files too!
  !insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
  ReserveFile "netbeans34.ini"
  ReserveFile "jdk14x.ini"
;------------------------------------------------------------------------------
;Modern UI System
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;Installer Sections
;------------------------------------------------------------------------------
Section $(TITLE_SecCopyUI) SecCopyUI

  ; Set output path to the installation directory.
  StrCpy $R5 $INSTDIR
  StrCpy $INSTDIR "$INSTDIR\Kelp5"
  StrCpy $OUTDIR "$INSTDIR\Kelp5"
  SetOutPath $INSTDIR

  File /r "..\..\NetBeans34\*.*"
	  
  !insertmacro MUI_INSTALLOPTIONS_READ $2 "netbeans34.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $3 "netbeans34.ini" "Field 4" "State" ;JDK Directory
  !insertmacro MUI_INSTALLOPTIONS_READ $9 "jdk14x.ini" "Field 3" "state" 
  StrCmp $9 0 continue
#Dumpstate::debug
  Call UpgradeJDKConfig
#  MessageBox MB_OK "End-Call UpgradeJDKConfig"
#Dumpstate::debug

  continue:
  ClearErrors
#  ExecWait '"$INSTDIR\configure.bat" "$R5" "$2"' $0	; start configuring Kelp
	nsExec::ExecToLog '"$INSTDIR\configure.bat" "$R5" "$2"'
	Pop $0                                                ; return value/error/timeout
	Pop $1                                                ; return value/error/timeout
  StrCmp $0 "0" success

	DetailPrint "Kelp ${VERSION} failed (output: $0)"
	Call Cleanup
	Goto end

	success:
	DetailPrint "Kelp ${VERSION} succeded (output: $0)"

  ; Write the installation path into the registry
  WriteRegStr HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans 3.4" "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans 3.4" "DisplayName" "Kelp ${VERSION} for NetBeans IDE 3.4 (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans 3.4" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteUninstaller "uninstall.exe"

	; Create Start Menu Shortcuts
  CreateDirectory "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4"
  CreateShortCut "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
	
	end:
SectionEnd
;------------------------------------------------------------------------------
;Installer Functions
;------------------------------------------------------------------------------
Function .onInit

# start splash screen
# the plugins dir is automatically deleted when the installer exits
		InitPluginsDir
		File /oname=$PLUGINSDIR\splash.bmp "${NSISDIR}\Modern UI\KelpForNetBeans34.bmp"
#optional
#File /oname=$PLUGINSDIR\splash.wav "C:\myprog\sound.wav"
		advsplash::show 1000 600 400 -1 $PLUGINSDIR\splash
		Pop $0 ; $0 has '1' if the user closed the splash screen early,
		                ; '0' if everything closed normal, and '-1' if some error occured.
# end splash screen

  ;Extract Install Options INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "netbeans34.ini"
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "jdk14x.ini"

  ReadRegStr $R0 HKLM "SOFTWARE\NetBeans\3.4" "PATH" 
  StrCmp $R0 "" continue
  StrCpy $INSTDIR $R0
  continue:

FunctionEnd
;---------------------------------------------------------------------------------
; Call when installation succeed
;---------------------------------------------------------------------------------
Function .onInstSuccess
FunctionEnd
;------------------------------------------------------------------------------
;Descriptions
;------------------------------------------------------------------------------
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
;------------------------------------------------------------------------------
;Uninstaller Section
;------------------------------------------------------------------------------
Section "Uninstall"
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans 3.4"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans 3.4"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4"
  RMDir /r "$INSTDIR"
  
SectionEnd
;------------------------------------------------------------------------------
;Uninstaller Functions
;------------------------------------------------------------------------------
Function un.onInit

  ;Get language from registry
  ReadRegStr $LANGUAGE HKCU "Software\${MUI_PRODUCT}" "Installer Language"

FunctionEnd
;------------------------------------------------------------------------------
; GetParent
; input, top of stack  (i.e. C:\Program Files\Poop)
; output, top of stack (replaces, with i.e. C:\Program Files)
; modifies no other variables.
;
; Usage:
;   Push "C:\Program Files\Directory\Whatever"
;   Call GetParent
;   Pop $0
;   ; at this point $0 will equal "C:\Program Files\Directory"
;------------------------------------------------------------------------------
Function GetParent
  Exch $0 ; old $0 is on top of stack
  Push $1
  Push $2
  StrCpy $1 -1
  loop:
    StrCpy $2 $0 1 $1
    StrCmp $2 "" exit
    StrCmp $2 "\" exit
    IntOp $1 $1 - 1
  Goto loop
  exit:
    StrCpy $0 $0 $1
    Pop $2
    Pop $1
    Exch $0 ; put $0 on top of stack, restore $0 to original value
FunctionEnd
;------------------------------------------------------------------------------
; Page to choose Enhydra install directory
;------------------------------------------------------------------------------
Function SetCustomPage

#  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans34.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"

  Call CheckEnhydraInstall  ; Check if Enhydra Server installed
	Call IfJavaExist          ; check if JAVA_HOME directory exist

	start:

  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "netbeans34.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error

  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP1} "netbeans34.ini" "Field 2" "State" ;Enhydra Directory
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "netbeans34.ini" "Field 4" "State" ;JDK Directory

	IfFileExists ${TEMP2}\bin\java.exe continue	; check if java.exe exist
	MessageBox MB_OK "File java.exe does not exist in directory ${TEMP2}\bin"
	Goto start
		
	continue:
	IfFileExists ${TEMP2}\bin\javac.exe checkJDK	; check if javac.exe exist
	MessageBox MB_OK "File javac.exe does not exist in directory ${TEMP2}\bin"
	Goto start

	checkJDK:
	IfFileExists ${TEMP2}\jre\lib\jsse.jar checkEnhydra	; check if JDK 1.4.x
	MessageBox MB_OK "File jsse.jar does not exist in directory ${TEMP2}\jre\lib"
	Goto start

	checkEnhydra:
	IfFileExists ${TEMP1}\lib\enhydra.jar end	; check if Enhydra exist
	MessageBox MB_OK "File enhydra.jar does not exist in directory ${TEMP2}\lib"
	Goto start

  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

	end:
	Pop $R0
FunctionEnd
;------------------------------------------------------------------------------
; Check if choosed java home directory
;------------------------------------------------------------------------------
Function IfJavaExist

  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans34.ini" "Settings" "Title" "$(TEXT_IO_PAGECUSTOM_A)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans34.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A)"
  !insertmacro MUI_INSTALLOPTIONS_READ ${TEMP2} "netbeans34.ini" "Field 4" "State"

  StrCmp ${TEMP2} "" end
  
	; predict if exist enviroment variable JAVA_HOME
  ReadEnvStr $6 "JAVA_HOME"

  StrCmp $6 "" notsetJAVA_HOME

	IfFileExists $6\bin\javac.exe OK ; check if javac.exe exist
	Goto notsetJAVA_HOME

  notsetJAVA_HOME:
 	ReadRegStr $6 HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\java.exe" "Path"
 	Push $6
  StrCmp $6 "" notregjava
 	Call GetParent
 	Pop $6
  StrCmp $6 "" notregjava
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto notregjava

	notregjava:
	ReadRegStr $1 HKLM "SOFTWARE\JavaSoft\Java Development Kit" "CurrentVersion"
	ReadRegStr $6 HKLM "SOFTWARE\JavaSoft\Java Development Kit\$1" "JavaHome"
 	Push $6
#  StrCmp $6 "" end
# 	Call GetParent
# 	Pop $6
	IfFileExists $6\bin\javac.exe OK	; check if javac.exe exist
	Goto end

	OK:
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans34.ini" "Field 4" "State" "$6"
	
	end:
FunctionEnd
;------------------------------------------------------------------------------
; Call on installation failed
;------------------------------------------------------------------------------
Function .onInstFailed
	Call Cleanup
FunctionEnd
;------------------------------------------------------------------------------
; Call when installation failed 
;------------------------------------------------------------------------------
Function Cleanup
  ; remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Kelp ${VERSION} for NetBeans 3.4"
  DeleteRegKey HKLM "SOFTWARE\Kelp ${VERSION} for NetBeans 3.4"

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\uninstall.exe

  ; remove shortcuts, if any.
  Delete "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4\*.*"

  ; remove directories used.
  RMDir "$SMPROGRAMS\Kelp ${VERSION} for NetBeans 3.4"
  RMDir /r "$INSTDIR"
  
FunctionEnd
;--------------------------------------------------------------------------
; Check if Enhydra Server installation exist
;--------------------------------------------------------------------------
Function CheckEnhydraInstall
  
  ReadRegStr $R0 HKLM "SOFTWARE\Enhydra${VERSION}" "Install_Dir" 
  StrCmp $R0 "" end
  ; set installation directory to <ENHYDRA_ROOT>\Director
  !insertmacro MUI_INSTALLOPTIONS_WRITE "netbeans34.ini" "Field 2" "State" $R0 
  
  end:
FunctionEnd
;====================================================
; StrStr - Finds a given string in another given string.
;               Returns -1 if not found and the pos if found.
;          Input: head of the stack - string to find
;                      second in the stack - string to find in
;          Output: head of the stack
;====================================================
Function StrStr
  Push $0
  Exch
  Pop $0 ; $0 now have the string to find
  Push $1
  Exch 2
  Pop $1 ; $1 now have the string to find in
  Exch
  Push $2
  Push $3
  Push $4
  Push $5

  StrCpy $2 -1
  StrLen $3 $0
  StrLen $4 $1
  IntOp $4 $4 - $3

  StrStr_loop:
    IntOp $2 $2 + 1
    IntCmp $2 $4 0 0 StrStrReturn_notFound
    StrCpy $5 $1 $3 $2
    StrCmp $5 $0 StrStr_done StrStr_loop

  StrStrReturn_notFound:
    StrCpy $2 -1

  StrStr_done:
    Pop $5
    Pop $4
    Pop $3
    Exch $2
    Exch 2
    Pop $0
    Pop $1
FunctionEnd
;------------------------------------------------------------------------------
; Page for choose java home directory
;------------------------------------------------------------------------------
Function SetCustomPageJDK

  StrCpy $R9 0 ; keep if selected upgrade the shared JDK definition to JDK 1.4.x
  
; set values in jdk14x.ini file
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "Title" "$(TEXT_IO_TITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 1" "Text" "$(TEXT_IO_PAGESUBTITLE_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Field 2" "Text" "$(TEXT_IO_PAGESUBTITLE_B_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "CancelButtonText" "$(TEXT_IO_CANCEL_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "NextButtonText" "$(TEXT_IO_NEXT_A_JDK)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "jdk14x.ini" "Settings" "BackButtonText" "$(TEXT_IO_BACK_A_JDK)"
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE_JDK)" "$(TEXT_IO_SUBTITLE_JDK)"

  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "jdk14x.ini"
	Pop $R0
  
   StrCmp $R0 "cancel" end
   StrCmp $R0 "back" end
   StrCmp $R0 "success" 0 error

  ; check if check box is selected
  !insertmacro MUI_INSTALLOPTIONS_READ $R1 "jdk14x.ini" "Field 3" "state" 
  StrCmp $R1 "0" end ; check if check box is selected
  StrCpy $R9 1
  Goto end
  
  error:
    MessageBox MB_OK|MB_ICONSTOP "InstallOptions error:$\r$\n${TEMP1}"

  end:
FunctionEnd
;-------------------------------------------------------------------------------
; Usage:
; Push "string1|string2|string3|string4|string5" 
; Call SplitFirstStrPart 
; Pop $R0 ;1st part ["string1"] 
; Pop $R1 ;rest ["string2|string3|string4|string5"] 
;-------------------------------------------------------------------------------
Function SplitFirstStrPart
  Exch $R0
  Push $R1
  Push $R2
  StrLen $R1 $R0
  IntOp $R1 $R1 + 1
  loop:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 1 -$R1
    StrCmp $R1 0 exit0
    StrCmp $R2 " " exit1 loop ; Change " " to "\" if str=dirpath
  exit0:
  StrCpy $R1 ""
  Goto exit2
  exit1:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 "" -$R1
    IntOp $R1 $R1 + 1
    StrCpy $R0 $R0 -$R1
    StrCpy $R1 $R2
  exit2:
  Pop $R2
  Exch $R1 ;rest
  Exch
  Exch $R0 ;first
FunctionEnd
;--------------------------------------------------------------------------
; Upgrade the JDK definition to JDK 1.4.x in file ide.cfg
;--------------------------------------------------------------------------
Function UpgradeJDKConfig
#  $R5 $INSTDIR
#  $2 Enhydra Directory
#  $3 JDK Directory

ClearErrors
IfFileExists "$R5\bin\ide.cfg.save" 0 start
Delete "$R5\bin\ide.cfg.save"
start:
FileOpen $9 "$R5\bin\ide.cfg" "r"
GetTempFileName $R4
FileOpen $8 $R4 "w"

StrCpy $R9 "" ; keep all file string
StrCpy $R8 "" ; keep current line string
StrCpy $7 0   ; indikator da postoji string "jdkhome"
StrCpy $5 0   ; indikator ukupno procitanih redova iz fajla
StrCpy $R7 ""  ; acumulate current line tokens
#MessageBox MB_OK "1"
#Dumpstate::debug
looprow:
   FileRead $9 $6
   IfErrors done
   IntOp $5 $5 + 1

loopstring: ; check if "-jdkhome" exist in current line readed from file
   Push $6
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
#MessageBox MB_OK "2"
#Dumpstate::debug
   IntCmp $0 -1 looprow 
   StrCpy $R8 $6

loop:
    ; get frst part of string
   Push $R8
   Call SplitFirstStrPart 
   Pop $R0 ;1st part
   Pop $R1 ;rest 
#MessageBox MB_OK "3"
#Dumpstate::debug
   StrCpy $R8 $R1 ;keep rest of string
   
   ; check if "-jdkhome" exist in frst part of string
   Push $R0 ; 
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
#MessageBox MB_OK "4"
#Dumpstate::debug
   StrCmp $0 -1 "" getjdkhome
   StrCpy $R7 "$R7$R0 " ; $R7 = $R7 + first part of string + " "
   goto loop
   
getjdkhome:   
   ; read java_home directory from string
   Push $R1 ;rest
   Call SplitFirstStrPart 
   Pop $R0 ;directory of java_home
   Pop $R1 ;rest 
#MessageBox MB_OK "5"
#Dumpstate::debug
   StrCpy $R7 "$R7-jdkhome $3 $R1"
   StrCpy $7 1
      
done:
#MessageBox MB_OK "6"
#Dumpstate::debug
   StrCmp $5 1 0 multiline
   StrCmp $7 1 0 notexistjdk
   FileWrite $8 $R7
   goto end
notexistjdk:
#MessageBox MB_OK "7"
   FileSeek $9 0 ; set to top of file
   FileRead $9 $6
#Dumpstate::debug
   FileWrite $8 "-jdkhome $3 $6"
   goto end
       
multiline:
#MessageBox MB_OK "8"
#Dumpstate::debug
   FileSeek $9 0 ; set to top of file
   StrCmp $7 0 "" multiexistjdk
#MessageBox MB_OK "8-1"
   FileWrite $8 "-jdkhome $3$\r$\n"
   goto multiloop
multiexistjdk:   
#MessageBox MB_OK "8-2"
   FileWrite $8 $R7
multiloop:
   FileRead $9 $6
   IfErrors end
   Push $6
   Push "-jdkhome"
   Call StrStr ; Find "-jdkhome" in $6
   Pop $0 ; pos of jdkhome
   IntCmp $0 -1 0 writejdkhome 
   FileWrite $8 $6
#MessageBox MB_OK "8-3-$$6=$6"
   goto multiloop 
writejdkhome:
   goto multiloop 

end:
#MessageBox MB_OK "9"
#Dumpstate::debug
   FileClose $9
#MessageBox MB_OK "10"
   FileClose $8
#MessageBox MB_OK "11"
   Rename "$R5\bin\ide.cfg" "$R5\bin\ide.cfg.save"
#MessageBox MB_OK "12-$$R4=$R4"
   CopyFiles /SILENT $R4 "$R5\bin\ide.cfg"
#MessageBox MB_OK "13"
   Delete $R4
#MessageBox MB_OK "14"
   StrCpy $0 0	; set OK
   
#MessageBox MB_OK "101"
#Dumpstate::debug

FunctionEnd
