#! /bin/bash
name=kelp
version=$(ls -1d kelp-*| grep -v 'tar.gz' |sed 's/kelp-//')
version=${version:=5.1}
	default_jdkdir=$(dirname $(which java 2>/dev/null) 2>/dev/null)/..
	if
		[[ $default_jdkdir = '/..' ]]
	then
		default_jdkdir=/usr/java/j2sdk1.4.0_01
	else
		cd $default_jdkdir
		default_jdkdir=$PWD
		cd -
	fi
	echo -e "\n\n $name-Eclipse21-$version post installation script\n\n"
	JDK_HOME=${JDK_HOME:=$JAVA_HOME}
        while
                err=0
                if
                        [ X$JDK_HOME = X ]
                then
                        text="Warning: JDK_HOME is not defined."
                        err=1
                elif
                        [ ! -d $JDK_HOME ]
                then
                        text="Warning: No such directory: $JDK_HOME."
                        err=1
                elif
                        [ ! -r $JDK_HOME/bin/javac ]
                then
                        text="Warning: Not valid directory (no javac file): $JDK_HOME."
                        err=1
                fi
                [ $err -gt 0 ]
        do
                echo $text
                echo -e "\n\nPlease enter path to your "\
                        "Java Development Kit - JDK directory [$default_jdkdir] \c"
                read JDK_HOME </dev/tty
                JDK_HOME=${JDK_HOME:=$default_jdkdir}
        done
        export JDK_HOME
	PATH=$JDK_HOME/bin:$PATH
	export PATH
        tools=$(find $JDK_HOME -name tools.jar -print)
        if
                echo $CLASSPATH | grep -v $tools
        then
                CLASSPATH=$CLASSPATH:$tools
                export CLASSPATH
        fi
	
	default_enhdir=/usr/local/enhydra5.1
        while
                echo -e "\n\nPlease enter path to your "\
                        "Enhydra root directory [$default_enhdir] \c"
                read enhdir </dev/tty
                enhdir=${enhdir:=$default_enhdir}
                [ ! -d $enhdir ]
        do
                echo "Warning: No such directory: $enhdir"
        done
	default_ecldir21=/opt/eclipse
        while
                echo -e "\n\nPlease enter path to your "\
                        "Eclipse21 root directory [$default_ecldir21] \c"
                read ecldir21 </dev/tty
                ecldir21=${ecldir21:=$default_ecldir21}
                [ ! -d $ecldir21 ]
        do
                echo "Warning: No such directory: $ecldir21"
        done
	kelpdir=${ecldir21}/plugins
	if
		[ ! -d ${kelpdir} ]
	then
		mkdir ${kelpdir}
	fi
	pluginName=$(basename $(ls -d  $name-$version/eclipse21/org.enhydra.kelp.eclipse*))
	if
		[ -d  ${kelpdir}/${pluginName} ]
	then
		echo "Kelp has already been installed, removing the contents of  ${kelpdir}/${pluginName}"
		rm -rf   ${kelpdir}/${pluginName}
	fi
	mv $name-$version/eclipse21/${pluginName} ${kelpdir}
	if
		$name-$version/eclipse21/configure  ${kelpdir}/${pluginName} $enhdir $JDK_HOME $CLASSPATH 
	then
		echo -e "\n\nThe installation has been successful"
	else
		echo -e "\n\nThe installation failed"
		exit 1
	fi


