/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 */
package org.enhydra.kelp.common;

// Common constants.
public interface Constants {

    // strings not to be resourced
    public static final String   TYPE_CHTML = "chtml";
    public static final String   TYPE_CLASS = "class";
    public static final String   TYPE_CONF = "conf";
    public static final String   TYPE_IN = "in";
    public static final String   TYPE_JAR = "jar";
    public static final String   TYPE_HTM = "htm";
    public static final String   TYPE_HTML = "html";
    public static final String   TYPE_JAVA = "java";
    public static final String   TYPE_MK = "mk";
    public static final String   TYPE_TMP = "tmp";
    public static final String   TYPE_TXT = "txt";
    public static final String   TYPE_WAR = "war";
    public static final String   TYPE_WML = "wml";
    public static final String   TYPE_XMLC = "xmlc";
    public static final String   TYPE_XHTML = "xhtml";

    //
    public static final String   DIR_CLASSES = "classes";
    public static final String   DIR_CONF = "conf";
    public static final String   DIR_CONTENT = "content";
    public static final String   DIR_INPUT = "input";
    public static final String   DIR_GEN_SOURCE = "Generated Source";
    public static final String   DIR_LIB = "lib";
    public static final String   DIR_OUTPUT = "output";
    public static final String   DIR_RESOURCES = "resources";
    public static final String   DIR_SRC = "src";

    //
    public static final String   FILE_BOOT_JAR = "Boot.jar";
    public static final String   FILE_ENHYDRA_JAR = "enhydra.jar";
    public static final String   FILE_XMLC_JAR = "xmlc.jar";
    public static final String   FILE_TOOLBOX_JAR = "toolbox.jar";
    public static final String   FILE_README = "readme.html";
    public static final String   FILE_EJB_JAR_XML = "ejb-jar.xml";
    public static final String   FILE_KERNEL_CONF = "kernel.conf";
    public static final String   FILE_CONFIG_MK = "config.mk";
    public static final String   FILE_MAKEFILE = "makefile";
    public static final String   FILE_MULTISERVER_CONF = "multiserver.conf";
    public static final String   FILE_BOOTSTRAP_CONF = "bootstrap.conf";
    public static final String   FILE_BOOTSTRAP4_CONF = "bootstrap4.conf";
    public static final String   FILE_KELP_TXT = "kelp.txt";
    public static final String   FILE_WEB_XML = "web.xml";
    public static final String   FILE_ENHYDRA_SERVICE_XML = "enhydra-service.xml";
    public static final String   FILE_JAVA_POLICY = "java.policy";
    public static final String   FILE_SERVLET_CONF = "servlet.conf";
    public static final String   FILE_START_SERVER = "StartServer.java";

    //
    public static final String JDK11 = "1.1";
    public static final String JDK12 = "1.2";
    public static final String JDK13 = "1.3";
    public static final String JAVA_VERSION = "java.version";

    //
    public static final String   TAB1 = " ";
    public static final String   TAB2 = "  ";
    public static final String   TAB4 = "    ";
    public static final String   NEWLINE = "\n";
    public static final String[] XMLC_NOOPS = {
        "-class", "-dump", "-info", "-javac", "-javacflag", "-javacopt",
        "-keep", "-methods", "-sourceout", "-verbose", "-version"
    };
    public static final String XMLC = "XMLC";
    public static final String KELP = "Kelp";
    public static final String ENHYDRA = "Enhydra";
    public static final String   TYPE_DODS = "doml";
//    public static final String   TYPE_UNIX_DIRECTORY = "/";
//    public static final String   TYPE_WINDOWS_DIRECTORY = "\\";
}
