/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 *
 */
package org.enhydra.kelp.common.bridge;

// XMLC imports - 1.x and 2.x
import org.enhydra.xml.xmlc.dom.XMLCDocument;
import org.w3c.dom.*;

// Standard imports
import java.lang.reflect.Method;

//
public class PrintInfoV1 extends PrintInfo {

    // string not to be resourced
    private final String GET_URLS_METHOD = "getElementURLAttrs"; // nores

    //
    public PrintInfoV1(Document doc, XMLCDocument xmlcDoc) {
        super(doc, xmlcDoc);
    }

    /**
     * Append URLs from an element.
     */
    protected void getElementURLs(Element element, XMLCDocument xmlcDoc) {

        // xmlcDoc.getElementURLAttrs(element);
        String[] attrs = new String[0];
        Method   targetMethod = null;
        Object[] args = new Object[1];

        args[0] = element;
        try {
            Method[] methods = xmlcDoc.getClass().getMethods();

            for (int i = 0; i < methods.length; i++) {
                if (methods[i].getName().equals(GET_URLS_METHOD)) {
                    targetMethod = methods[i];
                    break;
                }
            }
            if (targetMethod != null) {
                attrs = (String[]) targetMethod.invoke(xmlcDoc, args);
            }
            if (attrs == null) {
                return;    // No URLs in this node.
            }
            for (int idx = 0; idx < attrs.length; idx++) {
                String url = element.getAttribute(attrs[idx]);

                if ((url != null) && (url.length() > 0)) {
                    urls.addElement(url);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
