/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.codegen;

// ToolBox imports
import org.enhydra.tool.common.ExtensionFilter;
import org.enhydra.tool.codegen.internal.AppGenerator;
import org.enhydra.tool.codegen.ProjectOptionSet;
import org.enhydra.tool.codegen.CodeGen;
import org.enhydra.tool.codegen.OptionSet;
import org.enhydra.tool.codegen.GeneratorException;
import org.enhydra.tool.codegen.wizard.CodeGenWizard;
import org.enhydra.tool.codegen.wizard.CodeGenPanel;

// Kelp imports
import org.enhydra.kelp.KelpInfo;
import org.enhydra.kelp.common.Constants;
import org.enhydra.kelp.common.map.Mapper;
import org.enhydra.kelp.common.node.OtterNode;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.node.OtterFolderNode;
import org.enhydra.kelp.common.node.OtterJavaFileNode;
import org.enhydra.kelp.common.node.OtterTextFileNode;
import org.enhydra.kelp.common.node.OtterNodeFactory;
import org.enhydra.kelp.common.importer.ImportPaths;
import org.enhydra.kelp.common.importer.ImportTool;
import org.enhydra.kelp.common.ValidationException;

// Standard imports
import java.awt.Component;
import java.io.File;
import java.io.FileInputStream;
import java.io.FilenameFilter;
import java.util.Enumeration;
import java.util.Properties;
import java.util.Vector;
import java.util.ResourceBundle;

//
abstract public class AppGenUtil extends ProjectGenUtil {
    private Mapper              mapper = null;

    public AppGenUtil(AppGenerator gen) throws CodeGenException {
        super(gen);
    }

    public AppGenUtil(OtterProject p, AppGenerator gen) throws CodeGenException {
        super(p, gen);
    }


    // override ProjectGenUtil
    protected ImportPaths getImportPaths() throws CodeGenException {
        ImportPaths paths = null;
        AppGenerator appGen = null;
        String[][]  map = new String[0][2];

        paths= super.getImportPaths();
        appGen = (AppGenerator) getGenerator();

        try {
            map = appGen.expandAddinPackageMap();
            paths.setPackageMap(map);
        } catch (GeneratorException e) {
            throw new CodeGenException(e);
        }
        return paths;
    }

}
