/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.deployer;

// AddinCore
import org.enhydra.kelp.common.AbstractEchoBuilder;
import org.enhydra.kelp.common.event.WriteListener;

// ToolBox
import org.enhydra.tool.archive.ArchiveException;
import org.enhydra.tool.archive.PropertyReader;
import org.enhydra.tool.archive.ArchiveTool;
import org.enhydra.tool.archive.JarPlan;
import org.enhydra.tool.archive.WarPlan;
import org.enhydra.tool.archive.EjbPlan;
import org.enhydra.tool.archive.EarPlan;
import org.enhydra.tool.common.PathHandle;

// JDK
import java.io.File;
import java.util.Properties;
//
public class ArchiveBuilder extends AbstractEchoBuilder {
    //
    public ArchiveBuilder(WriteListener listener) {
        super(listener);
    }

    // implement AbstractEchoBuilder
    public void buildImpl() {
        ArchiveTool    tool = null;
        JarPlan[]      plans = new JarPlan[0];

        tool = new ArchiveTool();
        plans = getProject().getArchivePlans(true);

        for (int i = 0; i < plans.length; i++) {
            PathHandle ph = null;
            File       archive = null;

            try {

                plans[i].setClassFiltering(true);

        //Dusan
        if (plans[i] instanceof EjbPlan) {
        } else if (plans[i] instanceof EarPlan) {
        } else if (plans[i] instanceof WarPlan) {
        } else {
        }

//Dusan
//        if(getProject().getDeployType()==1) {
                archive = tool.buildArchive(plans[i]);
/*        } else if(getProject().getDeployType()==0) {
                archive = tool.buildArchive((JarPlan)plansw[i]);
        } */

                ph = PathHandle.createPathHandle(archive);
                if (ph.isFile()) {
                    echo("Created archive: " + ph.getPath());
                }
            } catch (ArchiveException e) {
                echo("Error creating : " + plans[i].getArchivePath());
                echo(e);
            }
        }
    }

}
