/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Lisa Reese
 *
 */


/*
 * ForteNodeFactory.java
 *
 * Created on May 3, 2001, 12:29 PM
 */

package org.enhydra.kelp.forte.node;

// ToolBox imports
import org.enhydra.tool.common.ToolException;
import org.enhydra.kelp.common.node.*;

import org.openide.nodes.Node;
import org.netbeans.modules.text.TXTDataObject;
/**
 *
 * @author  rees0234
 * @version
 */
public class ForteNodeFactory extends OtterNodeFactory {

    /** Creates new ForteNodeFactory */
    public ForteNodeFactory() {
    }

    public OtterFolderNode createFolderNode(OtterNode otterNode, String name) {
        OtterFolderNode newNode = null;

        newNode = new ForteFolderNode(otterNode, name);
        return newNode;
     }

    /**
     * Method declaration
     *
     *
     * @param otterNode
     * @param file
     *
     * @return
     */
    public OtterJavaFileNode createJavaFileNode(OtterNode otterNode,
                                                String file) {
        OtterJavaFileNode newNode = null;

        newNode = new ForteJavaFileNode(otterNode, file);
        return newNode;
    }

    /**
     * Method declaration
     *
     *
     * @param otterNode
     * @param file
     *
     * @return
     */
    public OtterDocumentNode createDocumentNode(OtterNode otterNode,
                                                String file) {
        OtterDocumentNode newNode = null;

        newNode = new ForteDocumentNode(otterNode, file);
        return newNode;

    }

    /**
     * Method declaration
     *
     *
     * @param otterNode
     * @param file
     *
     * @return
     */
    public OtterImageFileNode createImageFileNode(OtterNode otterNode,
            String file) {
        OtterImageFileNode newNode = null;

        newNode = new ForteImageFileNode(otterNode, file);
        return newNode;

    }

    /**
     * Method declaration
     *
     *
     * @param otterNode
     * @param file
     *
     * @return
     */
    public OtterTextFileNode createTextFileNode(OtterNode otterNode,
                                                String file) {

        OtterTextFileNode newNode = null;

        newNode = new ForteTextFileNode(otterNode, file);
        return newNode;

    }

    /**
     * Method declaration
     *
     *
     * @param otterNode
     * @param file
     *
     * @return
     */
    public OtterTemplateNode createTemplateNode(OtterNode otterNode,
                                                String file) {
        OtterTemplateNode newNode = null;

        newNode = new ForteTemplateNode(otterNode, file);
        return newNode;


    }

    /**
     * Method declaration
     *
     * @param otterNode
     *
     * @return
     */
    public OtterTemplateNode getTemplateNode(OtterNode otterNode) {
        OtterTemplateNode newNode = null;

        if (otterNode.getNativeNode() instanceof DeployDataObject) {
            DeployDataObject nativeNode = null;

            nativeNode = (DeployDataObject) otterNode.getNativeNode();
            try {
              newNode = new ForteTemplateNode(nativeNode);
            } catch (ToolException e) {
              e.printStackTrace();
            }
        }
        return newNode;
    }

    /**
     * Method declaration
     *
     *
     * @param project
     * @param node
     * @param files
     *
     * @return
     */
    public synchronized OtterJavaFileNode[] replaceGeneratedSource(OtterProject project,
            OtterNode node, String[] files) {

                System.out.println("replace generated source");
                return null;

        // Remove previously generated sources and then add
/*        OtterJavaFileNode[] javaNodes = new OtterJavaFileNode[files.length];
        Node           nativeProject = (Node) project.getNativeProject();
        Node            nativeNode = (Node) node.getNativeNode();
        Node[]              child = nativeNode.getChildren().getNodes();
        File                current = null;
        boolean             keep = false;

        for (int i = 0; i < child.length; i++) {
            if (child[i] instanceof FileNode) {
                FileNode cursor = null;

                cursor = (FileNode) child[i];
                for (int j = 0; j < files.length; j++) {
                    current = new File(files[j]);
                    if (cursor.getUrl().getFileObject().getAbsolutePath().equals(current.getAbsolutePath())) {
                        keep = true;
                        break;
                    }
                }
                if (!keep) {
                    cursor.setParent(null);
                    cursor.getUrl().getFileObject().delete();
                }
            }
        }
        for (int i = 0; i < files.length; i++) {
            try {
                Thread.sleep(100);
            } catch (Exception e) {
                e.printStackTrace();
            }
            javaNodes[i] = createJavaFileNode(node, files[i]);
        }
        return javaNodes;*/
    }


}
