package org.enhydra.kelp.eclipse.actions;


import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.debug.ui.actions.LaunchAction;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.externaltools.internal.launchConfigurations.ExternalToolsUtil;
import org.eclipse.ui.externaltools.internal.model.IExternalToolConstants;
import org.enhydra.tool.ToolBoxInfo;
import KelpEclipse21.KelpEclipse21Plugin;



/**
 * Insert the type's description here.
 * @see IWorkbenchWindowActionDelegate
 */
public class AntRebuildAction implements IWorkbenchWindowActionDelegate {

	/*z21
	 * ExternalTool antRebuildTool = null;
	 */
	IProject project = null;
	IWorkbenchWindow window = null;

	/**
	 * The constructor.
	 */
	public AntRebuildAction() {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#run
	 */
	public void run(IAction action)  {
		String prjName = null;
		String prjPath = null;
		project = null;
		
		IWorkbenchPage page = KelpEclipse21Plugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getActivePage();
		if (page != null) {
			ISelection selection = page.getSelection();
			if (selection instanceof IStructuredSelection) {
				IStructuredSelection ss = (IStructuredSelection)selection;
				if (!ss.isEmpty()) {
					Object obj = ss.getFirstElement();
					if (obj instanceof IJavaElement) {
						IResource res =((IJavaElement)obj).getResource();
						if (res == null)
							project = ((IJavaElement)obj).getJavaProject().getProject();
						else
							project = res.getProject();
							
					}
					if (obj instanceof IResource) {
							project = ((IResource)obj).getProject();
					}
				}
			}
		}
		if (project != null) {
			prjName = project.getName();
			prjPath = project.getLocation().toString();
		
		
		
//---------------------Dacha&Zorica---------------------------------
  
            window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
			IRunnableWithProgress runnable = new IRunnableWithProgress() {
				public void run(IProgressMonitor monitor) throws InvocationTargetException, InterruptedException {
					
					String location = ToolBoxInfo.getEnhydraRoot() + "/bin/ant";
					if (System.getProperty("os.name").toLowerCase().startsWith("windows")) 
						location += ".bat";
						
					HashMap args = new HashMap();
					args.put("!{tool_name}", "ant rebuild");
					args.put("!{tool_type}", IExternalToolConstants.TOOL_TYPE_PROGRAM);
					args.put("!{tool_args}", "rebuild");
					args.put("!{tool_refresh}", "${project}");
					//args.put("!{tool_build_types}", IExternalToolConstants.BUILD_TYPE_INCREMENTAL);
					args.put("!{tool_dir}", "${workspace_loc:/" + project.getName() + "}");
					args.put("!{tool_loc}", location);
					args.put("!{tool_block}", "true");
			
					ILaunchConfiguration conf = ExternalToolsUtil.configFromBuildCommandArgs(args);
					LaunchAction la = new LaunchAction(conf, ILaunchManager.RUN_MODE);
					
					la.run();
					
				};
			};
			try {
	            window.run(false, false, runnable);				
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else
			System.err.println("Fail to start Ant Rebuild, no project is selected!");
		
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#selectionChanged
	 */
	public void selectionChanged(IAction action, ISelection selection)  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#dispose
	 */
	public void dispose()  {
	}

	/**
	 * Insert the method's description here.
	 * @see IWorkbenchWindowActionDelegate#init
	 */
	public void init(IWorkbenchWindow window)  {
	}
}
