package org.enhydra.kelp.eclipse.ui.launcher;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.jdt.debug.ui.launchConfigurations.JavaMainTab;
import org.eclipse.jdt.internal.debug.ui.JDIDebugUIPlugin;
import org.eclipse.jdt.launching.IJavaLaunchConfigurationConstants;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.widgets.Composite;

/**
 * @author Administrator
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class EnhydraMainTab extends JavaMainTab {

	private static final String ENHYDRA_MAIN_CLASS = "com.lutris.multiServer.MultiServer";

	private EnhydraArgumentsTab eArgumentsTab = null;

	/**
	 * Constructor for EnhydraMainTab.
	 */
	public EnhydraMainTab() {
		super();
	}



	/**
	 * @see org.eclipse.debug.ui.ILaunchConfigurationTab#setDefaults(ILaunchConfigurationWorkingCopy)
	 */
	public void setDefaults(ILaunchConfigurationWorkingCopy configuration) {
		super.setDefaults(configuration);

		String mainName = "";

		try {
			// Main class name defaults to ENHYDRA_MAIN_CLASS
			mainName = configuration.getAttribute(IJavaLaunchConfigurationConstants.ATTR_MAIN_TYPE_NAME, EMPTY_STRING);
			if (mainName.compareTo(ENHYDRA_MAIN_CLASS) != 0)
				configuration.setAttribute(IJavaLaunchConfigurationConstants.ATTR_MAIN_TYPE_NAME, ENHYDRA_MAIN_CLASS);
		} catch (CoreException e) {
			JDIDebugUIPlugin.log(e);
		}
	}

	/**
	 * @see org.eclipse.debug.ui.ILaunchConfigurationTab#createControl(Composite)
	 */
	public void createControl(Composite parent) {
		super.createControl(parent);
		fProjText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent e) {
				UpdateEnhydraArgumentsTab();
			}
		});
	}

	/**
	 * Method UpdateEnhydraArgumentsTab.
	 */
	private void UpdateEnhydraArgumentsTab() {
		// Ovde bi trebalo da se ubaci promena direktorijuma
		// u kome se startuje aplikacija, kada se promeni
		// naziv projekta. Moguce ja da ovo i nije bitno.
	}

	/**
	 * Sets the eArgumentsTab.
	 * @param eArgumentsTab The eArgumentsTab to set
	 */
	public void setEArgumentsTab(EnhydraArgumentsTab eArgumentsTab) {
		this.eArgumentsTab = eArgumentsTab;
	}

}
