package org.enhydra.kelp.jbuilder.properties;

/**
 * <p>Title: </p>
 * <p>Description: New dialog for Kelp XML Compiler based on Ant tool.</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Slobodan Vujasinovic
 * @version 1.0
 */

// ToolBox
import org.enhydra.tool.ToolBoxInfo;
import org.enhydra.tool.common.DataValidationException;
import org.enhydra.tool.common.SwingUtil;

// AddinCore
import org.enhydra.kelp.KelpInfo;
import org.enhydra.kelp.common.Constants;
import org.enhydra.kelp.common.event.WriteEvent;
import org.enhydra.kelp.common.event.WriteListener;
import org.enhydra.kelp.common.node.OtterProject;
import org.enhydra.kelp.common.node.OtterFileNode;
import org.enhydra.kelp.common.node.OtterNode;
import org.enhydra.kelp.common.swing.AddinInnerPanel;
import org.enhydra.kelp.ant.xmlc.AntXMLCOptionsPanel;
import org.enhydra.kelp.common.node.OtterDocumentNode;
import org.enhydra.kelp.ant.node.AntProject;

// JDK
import java.util.ArrayList;
import java.util.Arrays;
import java.util.ResourceBundle;
import java.awt.*;
import java.beans.*;
import javax.swing.*;

//
public class XMLCOptionsPanel extends AddinInnerPanel {

    //
    static ResourceBundle          res =
        ResourceBundle.getBundle("org.enhydra.kelp.common.Res");
    private boolean                standalone = false;

    private GridBagLayout          layoutMain = null;
    private WriteListener[]        writeListeners = new WriteListener[0];
    AntXMLCOptionsPanel               optionsPanel = null;
	AntProject                     proj = null;
	
    public static XMLCOptionsPanel XMLCfindAncestor(Component comp) {
        Component      found = null;
        XMLCOptionsPanel ancestor = null;

        found = XMLCOptionsPanel.findAncestor(comp);
        if (found == null) {}
        else if (found instanceof XMLCOptionsPanel) {
            ancestor = (XMLCOptionsPanel) found;
        }
        return ancestor;
    }

    public XMLCOptionsPanel() {
        try {
            jbInit();
            pmInit();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    // overwrite org.enhydra.kelp.common.swing.InnerPanel
    public void clearAll() {
        super.clearAll();
        layoutMain = null;
        writeListeners = new WriteListener[0];
    }

    public AntXMLCOptionsPanel getOptionsPanel() {
        return optionsPanel;
    }

    public synchronized WriteListener[] getWriteListeners() {
        return writeListeners;
    }

    public synchronized void addWriteListener(WriteListener l) {
        ArrayList list = null;
        list = new ArrayList(Arrays.asList(writeListeners));
        if (!list.contains(l)) {
            list.add(l);
            list.trimToSize();
            writeListeners = new WriteListener[list.size()];
            writeListeners = (WriteListener[]) list.toArray(writeListeners);
        }
        list.clear();
    }

    public synchronized void removeWriteListener(WriteListener l) {
        ArrayList list = null;
        list = new ArrayList(Arrays.asList(writeListeners));
        if (list.contains(l)) {
            list.remove(l);
            list.trimToSize();
            writeListeners = new WriteListener[list.size()];
            writeListeners = (WriteListener[]) list.toArray(writeListeners);
        }
        list.clear();
    }


    // override AddinInnerPanel
    public void read(OtterNode node) {
        super.read(node);
        try{
          proj=new AntProject(getProject().getRootPath());
          optionsPanel.setProject(proj);
        } catch (Exception ex) {
            ex.printStackTrace();
        }

    }

    // override AddinInnerPanel
    public void write(OtterNode node) throws DataValidationException {
        super.write(node);
        if (getProject() == null) {
            System.err.println("AntXMLCInnerPanel.write(OtterProject p) : no project set");
        }
    }

    //
    // PRIVATE
    //
    // override AddinInnerPanel
    public void save() {
        super.save();
        proj.save();
    }

    /**
     * Add listeners and other items that are not generated by
     * the JBuilder designer.
     */
    private void pmInit() {
        this.add(optionsPanel,new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
                                        GridBagConstraints.CENTER,
                                        GridBagConstraints.BOTH,
                                        new Insets(5, 5, 5, 5), 5, 5));
    }

    /**
     * UI code generated by JBuilder.
     * <P><I>Do not modify the signature of this method.</I></P>
     * @throws Exception
     */
    private void jbInit() throws Exception {
        layoutMain =
            (GridBagLayout) Beans.instantiate(getClass().getClassLoader(),
                                              GridBagLayout.class.getName());

        optionsPanel = (AntXMLCOptionsPanel) Beans.instantiate(getClass().getClassLoader(),
                                                AntXMLCOptionsPanel.class.getName());

        this.setLayout(layoutMain);
    }

}
