/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */
package org.enhydra.kelp.common.dods;

import org.enhydra.dods.xslt.*;

import java.io.*;


public class DodsThread extends Thread {

    Generator gen = null;

	public DodsThread(Generator g) {
          gen = g;
	}


    public void run() {
      try {

      String javaPath = System.getProperty("javaPath");
      String enhydraPath = System.getProperty("enhydraPath");
      String s[] = new String[10];
      s[0] = javaPath+"/bin/java";
      s[1] =  "-classpath";
/* vl 20.07.03
      s[2] = ".;"+enhydraPath+"/lib/tools/xalan/xalan.jar;"+
      enhydraPath+"/lib/tools/xalan/bin/xml-apis.jar;"+
      enhydraPath+"/lib/build/ejen.jar;"+
      enhydraPath+"/lib/build/patches.jar;"+
      enhydraPath+"/lib/core.jar;"+
      enhydraPath+"/lib/util.jar;"+
      enhydraPath+"/lib/enhydra.jar;"+
      enhydraPath+"/lib/gnu-regexp.jar;"+
      enhydraPath+"/lib/xerces.jar;"+
      javaPath+"/jre/lib/rt.jar;"+
      javaPath+"/lib/tools.jar;"+
      enhydraPath+"/lib/build/dods.jar;"+
      enhydraPath+"/build/ant.jar;"+
      enhydraPath+"/build/anttask.jar";
*/
      s[2] = ".;"+//SV enhydraPath+"/lib/tools/xalan/xalan.jar;"+
      enhydraPath+"/dods/lib/ejen.jar;"+
      //SV enhydraPath+"/lib/build/patches.jar;"+
      enhydraPath+"/lib/core.jar;"+
      enhydraPath+"/lib/util.jar;"+
      enhydraPath+"/lib/enhydra.jar;"+
      enhydraPath+"/lib/gnu-regexp.jar;"+
      enhydraPath+"/lib/xercesImpl.jar;"+
      enhydraPath+"/lib/xml-apis.jar;"+
      javaPath+"/jre/lib/rt.jar;"+
      javaPath+"/lib/tools.jar;"+
      enhydraPath+"/dods/lib/dods.jar;"+
      enhydraPath+"/build/ant.jar;"+
      enhydraPath+"/build/anttask.jar";
// vl 20.07.03      
      s[3] =  "-DEJEN_HOME="+enhydraPath;
      s[4] =  "-DPROJECT_ROOT="+System.getProperty("projectRoot");
      s[5] = "-DDOML_FILE="+System.getProperty("domlFilePath");
      s[6] = "org.apache.tools.ant.Main";
      s[7] = "-f";
      s[8] = "C:/enhydra5/dods/generate.xml";
      s[9] = System.getProperty("dodsParameters");

      Process process = Runtime.getRuntime().exec(s);

      java.io.InputStream inputstream = process.getInputStream();
      BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(inputstream));
      java.io.InputStream inputstream1 = process.getErrorStream();
      BufferedReader bufferedreader1 = new BufferedReader(new InputStreamReader(inputstream1));

      String s1="";
      String s2="";

      while(((s1 = bufferedreader.readLine()) != null)||
        ((s2 = bufferedreader1.readLine()) != null)) {
	if (s1.indexOf("Processing") == -1)
          if(!s1.equals(""))
            gen.echo(s1);
	if (s2.indexOf("Processing") == -1)
          if(!s2.equals(""))
            gen.echo(s2);
      }

      process.waitFor();
      int k = process.exitValue();

    } catch (Exception e) {
      gen.echo("U threadu: error"+e);

    }
  }
}