
/*
 * Enhydra Java Application Server Project
 *
 * The contents of this file are subject to the Enhydra Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License on
 * the Enhydra web site ( http://www.enhydra.org/ ).
 *
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific terms governing rights and limitations
 * under the License.
 *
 * The Initial Developer of the Enhydra Application Server is Lutris
 * Technologies, Inc. The Enhydra Application Server and portions created
 * by Lutris Technologies, Inc. are Copyright Lutris Technologies, Inc.
 * All Rights Reserved.
 *
 * Contributor(s):
 * Paul Mahar
 *
 */

package org.enhydra.tool.archive.xml;

// ToolBox
import org.enhydra.tool.archive.ArchiveException;

// JDK
import java.io.InputStream;
import java.io.OutputStream;
import java.io.StringWriter;


//
public interface DescriptorHandler {
    public void setOutStream(OutputStream s);
    public OutputStream getOutputStream();
    public void setWriter(StringWriter w);
    public StringWriter getWriter();
    public String getSource();
    public void setSource(String s);
    public InputStream getInputStream();
    public void prep() throws ArchiveException;
}
